#!/usr/bin/env ruby
# frozen_string_literal: true

require 'csv'
require_relative '../lib/polynomial_table'

if ARGV.size != 1
  puts 'Usage: decode_polynomials.rb <csv_file>'
  exit 1
end

CSV_TABLE = CSV.table(ARGV[0])

k_relation = SPARQLprov.decode(CSV_TABLE)

k_relation.each do |answer, polynomial|
  puts "#{answer.inspect} => #{polynomial}"
end
