#include "rewritter.hpp"
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <random>
#include <regex>
#include <algorithm>
#include <sys/time.h>
#include <string>
#include <unordered_set>
#include <boost/algorithm/string.hpp>
#include <boost/spirit/include/qi.hpp>
#include <boost/regex.hpp>

namespace qi = boost::spirit::qi;

int main(int argc, char **argv)
{
  std::fstream query_file;
  std::string query = "";

  std::string usage = "rewrite (n|s|w|v) <query_file>";

  if (argc != 3 || strlen(argv[1]) != 1)
    {
      std::cout << "USAGE:" << usage << std::endl;
      exit(1);
    }

  query_file.open(argv[2], std::ios::in);
  if (query_file.is_open()){
    std::string tmp;
    while(getline(query_file, tmp)){
      query += tmp + "\n";
    }
    query_file.close();
  }

  std::string (*reify)(std::string, std::string);

  switch (argv[1][0]) {
  case 'n': reify = &named_graphs_reify; break;
  case 's': reify = &standard_reify; break;
  case 'w': reify = &wikidata_reify; break;
  case 'v': reify = &wikidata_variant_reify; break;
  default:
    std::cout << "Invalid argument: " << argv[1] << "\n"
              << "USAGE:" << usage << std::endl;
    exit(1);
  }

  RewrittenQuery rewritten_query;

  struct timeval timeStart, timeEnd;

  gettimeofday(&timeStart, NULL);
  // rewritten_query = rewrite(query, "?prov_", &named_graphs_reify);
  // rewritten_query = rewrite(query, "?prov_", &standard_reify);
  // rewritten_query = rewrite(query, "?prov_", &wikidata_reify);
  // rewritten_query = rewrite(query, "?prov_", &wikidata_variant_reify);
  rewritten_query = rewrite_with_prefix(query, "?prov_", reify);
  gettimeofday(&timeEnd, NULL);

  std::cout << rewritten_query.query << std::endl;

  // std::cout << "Runtime (microseconds): " <<
  //   ((timeEnd.tv_sec - timeStart.tv_sec) * 1000000 + timeEnd.tv_usec - timeStart.tv_usec) <<
  //   std::endl;

  return 0;
}
