# frozen_string_literal: true

require_relative './sparql_bench'

def isql(container, command)
  virtuoso = 'virtuoso-7.2.5.1'
  sh "lxc exec #{container} -- su - debian -c " \
     "'cd #{virtuoso}/bin && echo \"#{command}\" | ./isql'"
end

def isql_checkpoint(container)
  isql(container, 'checkpoint;')
  isql(container, 'commit work;')
  isql(container, 'checkpoint;')
end

def virtuoso_7_load_dataset(container)
  endpoint = LXDVirtuosoEndpoint.new(container)
  p container
  endpoint.service_start

  isql(container, 'SPARQL SELECT (count(*) as ?initial_triples) WHERE { ?s ?p ?o};')
  isql(container, "DB.DBA.VT_BATCH_UPDATE ('DB.DBA.RDF_OBJ', 'ON', NULL);")
  isql(container, 'DELETE FROM DB.DBA.load_list;')
  isql(container, "ld_dir ('/home/debian/dataset', '*', 'http://example.org/watdiv');")
  isql_checkpoint(container)
  isql(container, 'rdf_loader_run();')
  isql_checkpoint(container)
  isql(container, "DB.DBA.RDF_OBJ_FT_RULE_ADD (null, null, 'All');")
  isql(container, 'DB.DBA.VT_INC_INDEX_DB_DBA_RDF_OBJ ();')
  isql(container, 'SPARQL SELECT (count(*) as ?loaded_triples) WHERE { ?s ?p ?o };')
  isql_checkpoint(container)
end
