#!/usr/bin/env ruby
# frozen_string_literal: true

ENGINE = 'postgres'

%w[vp 6idx pso spo].each do |idx|
  %w[C1 C2 C3 F1 F2 F3 F4 F5 L1 L2 L3 L4 L5 S1 S2 S3 S4 S5 S6 S7].each do |template|
    %w[P].each do |mode| # before I used two modes B (base) and P (provenance)
      schema = case idx
               when 'spo'
                 'quads'
               when 'pso'
                 'quads'
               when '6idx'
                 'quads'
               when 'vp'
                 'vp'
               else
                 raise "Unsuported idx #{idx}"
               end

      (1..5).each do |iteration|
        Dir["watdiv/queries/100M/#{template}/#{schema}_postgres/#{mode}/*.sql"].to_a.sort.each do |query_file|
          puts "Running #{query_file} on ENGINE=#{ENGINE} IDX=#{idx} ITERATION=#{iteration}"
          query_name = query_file
                         .sub('watdiv/queries/', '')
                         .gsub('/', '-')
          answers_name = "#{ENGINE}-#{query_name.sub(/.sql$/, '.txt')}"
                           .sub('quads', idx)
                           .sub(/.txt$/, "-#{iteration}.txt")

          sh "lxc file push #{query_file} #{lxc_instance}/home/ubuntu/queries/#{query_name}"
          sh "lxc exec #{lxc_instance} -- su - ubuntu -c 'gprom -queryFile queries/#{query_name} " \
             "-backend postgres -host localhost -db prov -user prov -port 5432 -passwd prov -timing -time_queries > answers/#{answers_name}'"
          sh "lxc file pull #{lxc_instance}/home/ubuntu/answers/#{answers_name} " \
             "watdiv/answers/#{answers_name}"
        end
      end
    end
  end
end
