# frozen_string_literal: true

require_relative '../../lib/load_virtuoso'

[
  {
    name: 'namedgraphs',
    files: [["watdiv.#{WATDIV_SIZE}M-namedgraphs.nt.gz", "watdiv.#{WATDIV_SIZE}M-namedgraphs.nq.gz"]]
  },
  {
    name: 'rdf',
    files: [
      ["watdiv.#{WATDIV_SIZE}M-rdf.nt.gz", "watdiv.#{WATDIV_SIZE}M-rdf.nt.gz"],
      ["watdiv.#{WATDIV_SIZE}M.nt.gz", "watdiv.#{WATDIV_SIZE}M.nt.gz"]
    ]
  },
  {
    name: 'wikidata',
    files: [
      ["watdiv.#{WATDIV_SIZE}M-wikidata.nt.gz", "watdiv.#{WATDIV_SIZE}M-wikidata.nt.gz"],
      ["watdiv.#{WATDIV_SIZE}M.nt.gz", "watdiv.#{WATDIV_SIZE}M.nt.gz"]
    ]
  }
].each do |scheme|
  task_description =
    "Create WatDiv #{WATDIV_SIZE}M Virtuoso 7 container for #{scheme[:name]} reification scheme"
  task_name = "create_watdiv_#{WATDIV_SIZE}M_#{scheme[:name]}_virtuoso_7_container"

  desc task_description
  named_task task_name do
    container = "watdiv-#{WATDIV_SIZE}M-#{scheme[:name]}-virtuoso7-debian9"
    # system "lxc launch virtuoso7-debian9 #{container}"
    # scheme[:files].each do |file_pair|
    #   system "lxc file push watdiv/datasets/#{file_pair[0]} " \
    #          "#{container}/home/debian/dataset/#{file_pair[1]}"
    # end
    virtuoso_7_load_dataset(container)
  end

  desc task_description
  task "create_watdiv_#{scheme[:name]}_virtuoso": task_dependency(task_name)
end
